tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item > Class Template Reference
Algorithms

For internal use only. More...

`#include <parallel_do.h>`

Inheritance diagram for tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >:
Collaboration diagram for tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >:

## Private Types

typedef parallel_do_feeder_impl< Body, Item > | feeder_type

## Private Member Functions

| do_group_task_forward (Iterator first, size_t size, feeder_type &feeder)
task * | execute () __TBB_override
| Should be overridden by derived classes. More...

## Private Attributes

feeder_type & | my_feeder
Iterator | my_first
size_t | my_size

## Static Private Attributes

static const size_t | max_arg_size = 4

## Friends

template<typename Iterator_ , typename Body_ , typename _Item >
class | do_task_iter

## Additional Inherited Members

Public Types inherited from tbb::task
enum | state_type { executing, reexecute, ready, allocated, freed, recycle }
| Enumeration of task states that the scheduler considers. More...
typedef internal::affinity_id | affinity_id
| An id as used for specifying affinity. More...
Public Member Functions inherited from tbb::task
virtual | ~task ()
| Destructor. More...
internal::allocate_continuation_proxy & | allocate_continuation ()
| Returns proxy for overloaded new that allocates a continuation task of *this. More...
internal::allocate_child_proxy & | allocate_child ()
| Returns proxy for overloaded new that allocates a child task of *this. More...
void | recycle_as_continuation ()
| Change this to be a continuation of its former self. More...
void | recycle_as_safe_continuation ()
| Recommended to use, safe variant of recycle_as_continuation. More...
void | recycle_as_child_of (task &new_parent)
| Change this to be a child of new_parent. More...
void | recycle_to_reexecute ()
| Schedule this for reexecution after current execute() returns. More...
void | set_ref_count (int count)
| Set reference count. More...
void | increment_ref_count ()
| Atomically increment reference count. More...
int | add_ref_count (int count)
| Atomically adds to reference count and returns its new value. More...
int | decrement_ref_count ()
| Atomically decrement reference count and returns its new value. More...
void | spawn_and_wait_for_all (task &child)
| Similar to spawn followed by wait_for_all, but more efficient. More...
void __TBB_EXPORTED_METHOD | spawn_and_wait_for_all (task_list &list)
| Similar to spawn followed by wait_for_all, but more efficient. More...
void | wait_for_all ()
| Wait for reference count to become one, and set reference count to zero. More...
task * | parent () const
| task on whose behalf this task is working, or NULL if this is a root. More...
void | set_parent (task *p)
| sets parent task pointer to specified value More...
task_group_context * | context ()
| This method is deprecated and will be removed in the future. More...
task_group_context * | group ()
| Pointer to the task group descriptor. More...
bool | is_stolen_task () const
| True if task was stolen from the task pool of another thread. More...
bool | is_enqueued_task () const
| True if the task was enqueued. More...
state_type | state () const
| Current execution state. More...
int | ref_count () const
| The internal reference count. More...
bool __TBB_EXPORTED_METHOD | is_owned_by_current_thread () const
| Obsolete, and only retained for the sake of backward compatibility. Always returns true. More...
void | set_affinity (affinity_id id)
| Set affinity for this task. More...
affinity_id | affinity () const
| Current affinity of this task. More...
virtual void __TBB_EXPORTED_METHOD | note_affinity (affinity_id id)
| Invoked by scheduler to notify task that it ran on unexpected thread. More...
void __TBB_EXPORTED_METHOD | change_group (task_group_context &ctx)
| Moves this task from its current group into another one. More...
bool | cancel_group_execution ()
| Initiates cancellation of all tasks in this cancellation group and its subordinate groups. More...
bool | is_cancelled () const
| Returns true if the context has received cancellation request. More...
__TBB_DEPRECATED void | set_group_priority (priority_t p)
| Changes priority of the task group this task belongs to. More...
__TBB_DEPRECATED priority_t | group_priority () const
| Retrieves current priority of the task group this task belongs to. More...
Static Public Member Functions inherited from tbb::task
static internal::allocate_root_proxy | allocate_root ()
| Returns proxy for overloaded new that allocates a root task. More...
static internal::allocate_root_with_context_proxy | allocate_root (task_group_context &ctx)
| Returns proxy for overloaded new that allocates a root task associated with user supplied context. More...
static void | spawn_root_and_wait (task &root)
| Spawn task allocated by allocate_root, wait for it to complete, and deallocate it. More...
static void | spawn_root_and_wait (task_list &root_list)
| Spawn root tasks on list and wait for all of them to finish. More...
static void | enqueue (task &t)
| Enqueue task for starvation-resistant execution. More...
static __TBB_DEPRECATED void | enqueue (task &t, priority_t p)
| Enqueue task for starvation-resistant execution on the specified priority level. More...
static __TBB_DEPRECATED void | enqueue (task &t, task_arena &arena, priority_t p=priority_t(0))
| Enqueue task in task_arena. More...
static task &__TBB_EXPORTED_FUNC | self ()
| The innermost task being executed or destroyed by the current thread at the moment. More...
Protected Member Functions inherited from tbb::task
| task ()
| Default constructor. More...

## Detailed Description

### template<typename Iterator, typename Body, typename Item>
class tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >

For internal use only.

Unpacks a block of iterations.

Definition at line 212 of file parallel_do.h.

## Member Typedef Documentation

## feeder_type

template<typename Iterator , typename Body , typename Item >

typedef parallel_do_feeder_impl<Body, Item> tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::feeder_type

private

Definition at line 216 of file parallel_do.h.

## Constructor & Destructor Documentation

## do_group_task_forward()

template<typename Iterator , typename Body , typename Item >

tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::do_group_task_forward | ( | Iterator | first,
|  | size_t | size,
|  | feeder_type & | feeder
| ) |  |

inline private

Definition at line 222 of file parallel_do.h.

: my_feeder(feeder), my_first(first), my_size(size)
{}

## Member Function Documentation

## execute()

template<typename Iterator , typename Body , typename Item >

task* tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::execute | ( |  | ) |

inline private virtual

Should be overridden by derived classes.

Implements tbb::task.

Definition at line 226 of file parallel_do.h.

{
typedef do_iteration_task_iter<Iterator, Body, Item> iteration_type;
__TBB_ASSERT( my_size>0, NULL );
task_list list;
task* t;
size_t k=0;
for(;;) {
t = new( allocate_child() ) iteration_type( my_first, my_feeder );
++my_first;
if( ++k==my_size ) break;
list.push_back(*t);
}
set_ref_count(int(k+1));
spawn(list);
spawn_and_wait_for_all(*t);
return NULL;
}

References __TBB_ASSERT, tbb::task::allocate_child(), tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_feeder, tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_first, tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_size, tbb::task_list::push_back(), tbb::task::set_ref_count(), and tbb::task::spawn_and_wait_for_all().

Here is the call graph for this function:

## Friends And Related Function Documentation

## do_task_iter

template<typename Iterator , typename Body , typename Item >
template<typename Iterator_ , typename Body_ , typename _Item >

friend class do_task_iter

friend

Definition at line 245 of file parallel_do.h.

## Member Data Documentation

## max_arg_size

template<typename Iterator , typename Body , typename Item >

const size_t tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::max_arg_size = 4

static private

Definition at line 214 of file parallel_do.h.

## my_feeder

template<typename Iterator , typename Body , typename Item >

feeder_type& tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_feeder

private

Definition at line 218 of file parallel_do.h.

Referenced by tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::execute().

## my_first

template<typename Iterator , typename Body , typename Item >

Iterator tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_first

private

Definition at line 219 of file parallel_do.h.

Referenced by tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::execute().

## my_size

template<typename Iterator , typename Body , typename Item >

size_t tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::my_size

private

Definition at line 220 of file parallel_do.h.

Referenced by tbb::interface9::internal::do_group_task_forward< Iterator, Body, Item >::execute().

The documentation for this class was generated from the following file:

- parallel_do.h

tbb::task::set_ref_count
void set_ref_count(int count)
Set reference count.
Definition: task.h:750
__TBB_ASSERT
#define __TBB_ASSERT(predicate, comment)
No-op version of __TBB_ASSERT.
Definition: tbb_stddef.h:165
tbb::interface9::internal::do_group_task_forward::my_size
size_t my_size
Definition: parallel_do.h:220
tbb::task::allocate_child
internal::allocate_child_proxy & allocate_child()
Returns proxy for overloaded new that allocates a child task of *this.
Definition: task.h:670
tbb::interface9::internal::do_group_task_forward::my_feeder
feeder_type & my_feeder
Definition: parallel_do.h:218
tbb::task::spawn_and_wait_for_all
void spawn_and_wait_for_all(task &child)
Similar to spawn followed by wait_for_all, but more efficient.
Definition: task.h:789
size
void const char const char int ITT_FORMAT __itt_group_sync x void const char ITT_FORMAT __itt_group_sync s void ITT_FORMAT __itt_group_sync p void ITT_FORMAT p void ITT_FORMAT p no args __itt_suppress_mode_t unsigned int void size_t size
Definition: ittnotify_static.h:109
tbb::task::task
task()
Default constructor.
Definition: task.h:614
tbb::internal::first
auto first(Container &c) -> decltype(begin(c))
Definition: _range_iterator.h:34
tbb::interface9::internal::do_group_task_forward::my_first
Iterator my_first
Definition: parallel_do.h:219
tbb::task::task_list
friend class task_list
Definition: task.h:979

Copyright © 2005-2020 Intel Corporation. All Rights Reserved.

Intel, Pentium, Intel Xeon, Itanium, Intel XScale and VTune are registered trademarks or trademarks of Intel Corporation or its subsidiaries in the United States and other countries.

* Other names and brands may be claimed as the property of others.